﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.3
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
End Sub

Sub LnBD(BD As BigDecimal) As String				'ignore
	'BDLnX = 2[N + 1/3N^3 + 1/5N^5 + ...] 	 x>0
	'N = (x-1/x+1)
	Private N, Nn, Nd, Nnew, BDLnx, Characteristic, Mantissa, TempBD As BigDecimal
	Private RBD As String
	Characteristic.Initialize(0)
	Mantissa.Initialize(0)

	'Check if BD is greater than zero,  return if not.
	If WrapNumberBD(BD.CompareTo(WrapNumberBD(0))).equals(WrapNumberBD(1)) = False Then
		RBD = "Error"
		Return 	RBD										
	End If
	
	'Determine Characteristic and convert to Standard Form
	Do While WrapNumberBD(BD.CompareTo(WrapNumberBD(cE))).Equals(WrapNumberBD(-1)) = False
		BD.Divide2(WrapNumberBD(cE),BD.Precision-BD.Scale+40,BD.ROUND_HALF_UP)
		Characteristic.Add(WrapNumberBD(1))
	Loop
	Do While WrapNumberBD(BD.CompareTo(WrapNumberBD(1))).Equals(WrapNumberBD(-1))
		BD.Multiply(WrapNumberBD(cE))
		Characteristic.Subtract(WrapNumberBD(1))
	Loop

	'Calculate N.	N = (x-1/x+1)
	Nn.Initialize5(BD): 	Nn.Subtract(WrapNumberBD(1))
	Nd.Initialize5(BD): 	Nd.Add(WrapNumberBD(1))
	N.Initialize5(Nn):
	N.Divide2(Nd,Nd.Precision-Nd.Scale+20,N.ROUND_HALF_UP)
	
	TempBD.Initialize(0.00000000000000000001)		'Consider anything less than this to be too small
	'Determine Mantissa
	For J = 1 To 200 Step 2
		Nnew.Initialize5(N):
		Nnew.Pow(J)
		If WrapNumberBD(Nnew.CompareTo(TempBD)).equals(WrapNumberBD(1)) = False Then 
'Log(J)
			Exit   'Exit loop if numbers become to small
		End If
		Nnew.Divide2(WrapNumberBD(J),Nnew.Precision-Nnew.Scale+20,Nnew.ROUND_HALF_UP)
		Mantissa.Add(Nnew)
	Next
	Mantissa.Multiply(WrapNumberBD(2))
	BDLnx.Initialize5(Characteristic):		BDLnx.Add(Mantissa)
	RBD = BDLnx.ToPlainString
	Return RBD
	
End Sub

Sub Log10BD(BD As BigDecimal) As String				'ignore
	'BDLnX = 2[N + 1/3N^3 + 1/5N^5 + ...] 	 x>0
	'N = (x-1/x+1)
	Private N, Nn, Nd, Nnew, BDLnx, BDLog, Characteristic, Mantissa, TempBD, eTo10 As BigDecimal
	Private RBD As String
	Characteristic.Initialize(0)
	Mantissa.Initialize(0)
	eTo10.Initialize(2.3025850929940456840179914546844)

	'Check if BD is greater than zero,  return if not.
	If WrapNumberBD(BD.CompareTo(WrapNumberBD(0))).equals(WrapNumberBD(1)) = False Then
		RBD = "Error"
		Return 	RBD										
	End If
	
	'Determine Characteristic and convert to Standard Form
	Do While WrapNumberBD(BD.CompareTo(WrapNumberBD(cE))).Equals(WrapNumberBD(-1)) = False
		BD.Divide2(WrapNumberBD(cE),BD.Precision-BD.Scale+40,BD.ROUND_HALF_UP)
		Characteristic.Add(WrapNumberBD(1))
	Loop
	Do While WrapNumberBD(BD.CompareTo(WrapNumberBD(1))).Equals(WrapNumberBD(-1))
		BD.Multiply(WrapNumberBD(cE))
		Characteristic.Subtract(WrapNumberBD(1))
	Loop

	'Calculate N.	N = (x-1/x+1)
	Nn.Initialize5(BD): 	Nn.Subtract(WrapNumberBD(1))
	Nd.Initialize5(BD): 	Nd.Add(WrapNumberBD(1))
	N.Initialize5(Nn):
	N.Divide2(Nd,Nd.Precision-Nd.Scale+40,N.ROUND_HALF_UP)
	
	TempBD.Initialize(0.00000000000000000001)		'Consider anything less than this to be too small
	'Determine Mantissa
	For J = 1 To 200 Step 2
		Nnew.Initialize5(N):
		Nnew.Pow(J)
		If WrapNumberBD(Nnew.CompareTo(TempBD)).equals(WrapNumberBD(1)) = False Then Exit   'Exit loop if numbers become to small
		Nnew.Divide2(WrapNumberBD(J),Nnew.Precision-Nnew.Scale+20,Nnew.ROUND_HALF_UP)
		Mantissa.Add(Nnew)
	Next
	Mantissa.Multiply(WrapNumberBD(2))
	BDLnx.Initialize5(Characteristic):		BDLnx.Add(Mantissa)
	BDLog.Initialize5(BDLnx):	BDLog.Divide2(eTo10, BDLnx.Precision-BDLnx.Scale+20, BDLog.ROUND_HALF_UP)
	RBD = BDLog.ToPlainString
	Return RBD
	
End Sub

Sub eXBD(BD As BigDecimal) As String				'ignore
	'eXBD = 1 + X^N/N! + X^N/N! + .........
	Private X, ResBD, NFact,TempBD As BigDecimal
	Private RBD As String
	
	ResBD.Initialize(0)
	NFact.Initialize(1)
	TempBD.Initialize(0.00000000000000000001)		'Consider anything less than this to be too small
	
	For N = 1 To 500 Step 1
		NFact.Multiply(WrapNumberBD(N))
		X.Initialize5(BD)
		X.Pow(N)
		If WrapNumberBD(x.CompareTo(TempBD)).equals(WrapNumberBD(1)) = False Then
			Exit   'Exit loop if numbers become to small
		End If
		X.Divide2(NFact,X.Precision-X.Scale+20,X.ROUND_HALF_UP)
		ResBD.Add(X)
	Next
	ResBD.Add(WrapNumberBD(1))
	RBD = ResBD.ToPlainString
	Return RBD
End Sub

Sub TenXBD(BD As BigDecimal) As String				'ignore
	'BD * 2.302.........
	'eXBD = 1 + X^N/N! + X^N/N! + .........
	Private X, ResBD, NFact, eTo10, To10BD As BigDecimal
	Private RBD As String
	
	ResBD.Initialize(0)
	NFact.Initialize(1)
	eTo10.Initialize(2.3025850929940456840179914546844)
	To10BD.Initialize5(BD):		To10BD.Multiply(eTo10)
	
	For N = 1 To 1000 Step 1
		NFact.Multiply(WrapNumberBD(N))
		X.Initialize5(To10BD)
		X.Pow(N).Divide2(NFact,X.Precision-X.Scale+20,X.ROUND_HALF_UP)
		ResBD.Add(X)
	Next
	ResBD.Add(WrapNumberBD(1))
	RBD = ResBD.ToPlainString
	Return RBD
End Sub

Sub WrapNumberBD (d As Double) As BigDecimal					'Erels code
	Private b As BigDecimal
	b.Initialize(d)
	Return b
End Sub